<?php
/**
 * @file
 * commerce_eu_vat.rules.inc
 */

/**
 * Implements hook_rules_condition_info().
 */
function commerce_eu_vat_rules_condition_info() {

  $conditions = array();

  $conditions['commerce_eu_vat_rules_site_is_in_eu'] = array(
    'label' => t("The site's default country is in the EU"),
    'group' => t('Commerce EU VAT'),
    'callbacks' => array(
      'execute' => 'commerce_eu_vat_rules_site_is_in_eu',
    ),
  );

  return $conditions;
}

/**
 * Callback function to check if the sites default country is in the EU.
 */
function commerce_eu_vat_rules_site_is_in_eu() {

  $default_country = variable_get('site_default_country', NULL);
  $eu_countries = _commerce_eu_vat_eu_countries();

  if (array_key_exists($default_country, $eu_countries)) {
    return TRUE;
  }
  else {
    return FALSE;
  }
}
