<?php
/**
 * @file
 * Commerce EU VAT Intra-Community Supply Rules
 */

/**
 * Impliments hook_default_rules_configuration_alter().
 */
function commerce_eu_vat_ic_default_rules_configuration_alter(&$configs) {

  // Add a condition to not allow use of IC RC on home country.
  $tax_rates = commerce_tax_rates();

  foreach ($tax_rates as $tax_rate) {
    if ($tax_rate['type'] == 'eu_vat' && isset($configs[$tax_rate['rules_component']])) {
      $country = substr($tax_rate['module'], -2);

      $configs[$tax_rate['rules_component']]
      ->condition(rules_and()
        ->condition(rules_condition('component_commerce_eu_vat_rules_place_of_supply_' . $country, array('commerce_order:select' => 'commerce-line-item:order'))->negate())
        ->condition('component_commerce_eu_vat_rules_order_has_vat_number', array('commerce_order:select' => 'commerce-line-item:order'))
        ->negate()
      );
    }
  }
}
