<?php
/**
 * @file
 * commerce_eu_vat_cz.rules_defaults.inc
 */

/**
 * Impliments hook_default_rules_configuration_alter().
 */
function commerce_eu_vat_cz_default_rules_configuration_alter(&$configs) {
  // Change the place of supply rules.
  $country = 'CZ';
  _commerce_eu_vat_configure_place_of_supply($configs, $country);

  // Add date condition 2013 17.5% VAT rate.
  if (isset($configs['commerce_tax_rate_eu_vat_cz_standard_175'])) {
    $configs['commerce_tax_rate_eu_vat_cz_standard_175']
    ->condition(rules_or()
      ->condition('data_is', array('data:select' => 'commerce-line-item:order:created', 'op' => '>', 'value' => strtotime('2013-01-01')))
      ->condition(rules_and()
        ->condition('data_is_empty', array('data:select' => 'commerce-line-item:order:created'))
        ->condition('data_is', array('data:select' => 'site:current-date', 'op' => '>', 'value' => strtotime('2013-01-01')))
      )
    );
  }

  // Add date condition to 20% VAT rate.
  if (isset($configs['commerce_tax_rate_eu_vat_cz_standard_20'])) {
    $configs['commerce_tax_rate_eu_vat_cz_standard_20']
    ->condition(rules_or()
      ->condition('data_is', array('data:select' => 'commerce-line-item:order:created', 'op' => '<', 'value' => strtotime('2013-01-01')))
      ->condition(rules_and()
        ->condition('data_is_empty', array('data:select' => 'commerce-line-item:order:created'))
        ->condition('data_is', array('data:select' => 'site:current-date', 'op' => '<', 'value' => strtotime('2013-01-01')))
      )
    );
  }

  // Add date condition to 10% VAT rate.
  if (isset($configs['commerce_tax_rate_eu_vat_cz_reduced_10'])) {
    $configs['commerce_tax_rate_eu_vat_cz_reduced_10']
    ->condition(rules_or()
      ->condition('data_is', array('data:select' => 'commerce-line-item:order:created', 'op' => '<', 'value' => strtotime('2013-01-01')))
      ->condition(rules_and()
        ->condition('data_is_empty', array('data:select' => 'commerce-line-item:order:created'))
        ->condition('data_is', array('data:select' => 'site:current-date', 'op' => '<', 'value' => strtotime('2013-01-01')))
      )
    );
  }

}
