<?php
/**
 * @file
 * commerce_eu_vat_gb.rules_defaults.inc
 */

/**
 * Impliments hook_default_rules_configuration_alter().
 */
function commerce_eu_vat_de_default_rules_configuration_alter(&$configs) {
  // Change the place of supply rules.
  $country = 'DE';
  _commerce_eu_vat_configure_place_of_supply($configs, $country);

  // Add date condition to 19% VAT rate.
  if (isset($configs['commerce_tax_rate_eu_vat_de_standard_19'])) {
    $configs['commerce_tax_rate_eu_vat_de_standard_19']
    ->condition(rules_or()
      ->condition('data_is', array('data:select' => 'commerce-line-item:order:created', 'op' => '>', 'value' => strtotime('2007-01-01')))
      ->condition(rules_and()
        ->condition('data_is_empty', array('data:select' => 'commerce-line-item:order:created'))
        ->condition('data_is', array('data:select' => 'site:current-date', 'op' => '>', 'value' => strtotime('2007-01-01')))
      )
    );
  }

  // Add date condition to 16% VAT rate.
  if (isset($configs['commerce_tax_rate_eu_vat_de_standard_16'])) {
    $configs['commerce_tax_rate_eu_vat_de_standard_16']
    ->condition('data_is', array('data:select' => 'commerce-line-item:order:created', 'op' => '<', 'value' => strtotime('2007-01-01')));
  }
}
